module Ticketlocker
  class TicketCollection
    extend Forwardable

    def_delegators :@tickets, :[]

    def find(id)
      tickets.detect { |ticket| ticket.id == id }
    end

    def self.retrieve
      response = Ticketlocker.connection.get('/api/tickets')
      if response.status == 200
        tickets = response.body
      else
        "It's broken"
      end
      new(tickets)
    end

    private
    attr_reader :tickets

    def initialize(tickets)
      @tickets = tickets.map { |ticket| Ticket.new(ticket) }
    end
  end
end

